(***************************************************)
(*** С 饤ȥץץ mak ***)
(***************************************************)

(* $Id: mak.ml 10 2005-07-22 06:29:21Z mame $ *)

open Reversi
open Rvclient

let scores =
    let f = [[9; 2; 8; 7]; [2; 1; 3; 4]; [8; 3; 5; 6]; [7; 4; 6; 0]] in
    List.fold_left
        (fun l z -> z::l@[z])
        []
        (List.rev_map (fun l -> l @ (List.rev l)) f)

let rec loop () =
    match get () with
    | Game_start id -> loop ()
    | Game_end win -> ()
    | Set_start (clr, rst) -> loop ()
    | Set_end (slf, opp) -> loop ()
    | Next state ->
        let brd = transform state.board in
        (*
        print_board brd;
        *)
        let rec collect_y y r = function
        | [] -> r
        | hd::tl -> collect_y (succ y) (collect_x 0 y r hd) tl
        and collect_x x y r = function
        | [] -> r
        | hd::tl ->
            let r = if can_put brd state.color x y then (hd, x, y)::r else r in
            collect_x (succ x) y r tl
        in
        let (sc, a) =
            List.fold_left
                (fun (sc, r) (sc2, x, y) ->
                    if sc < sc2 then (sc2, [x, y])
                    else if sc > sc2 then (sc, r)
                    else (sc, (x, y)::r))
                (-1, [-1, -1])
                (collect_y 0 [] scores)
        in
        let (x, y) = List.nth a (Random.int (List.length a)) in
        (*
        let s = "  " in
        s.[0] <- "ABCDEFGH".[x];
        s.[1] <- "12345678".[y];
        print_endline ("move: " ^ s);
        *)
        put x y; loop ()

let _ =
    Random.self_init ();
    init "mak";
    loop ()
